--
-- kolos
-- This is the specialization for combines
--
-- @author  Stefan Geiger
-- @date  30/11/08
--
-- Copyright (C) GIANTS Software GmbH, Confidential, All Rights Reserved.

kolos = {};

function kolos.prerequisitesPresent(specializations)
return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function kolos:load(xmlFile)
      

	
	local rotationPartNodeabl3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.abl3#index"));
    if rotationPartNodeabl3 ~= nil then
        self.rotationPartabl3 = {};
        self.rotationPartabl3.node = rotationPartNodeabl3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartabl3#minRot"));
        self.rotationPartabl3.minRot = {};
        self.rotationPartabl3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.abl3#maxRot"));
        self.rotationPartabl3.maxRot = {};
        self.rotationPartabl3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartabl3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl3#rotTime"), 2)*1000;
        self.rotationPartabl3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl3#touchRotLimit"), 10));
    end;
local rotationPartNodeabl1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.abl1#index"));
    if rotationPartNodeabl1 ~= nil then
        self.rotationPartabl1 = {};
        self.rotationPartabl1.node = rotationPartNodeabl1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartabl1#minRot"));
        self.rotationPartabl1.minRot = {};
        self.rotationPartabl1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.abl1#maxRot"));
        self.rotationPartabl1.maxRot = {};
        self.rotationPartabl1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartabl1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl1#rotTime"), 2)*1000;
        self.rotationPartabl1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl1#touchRotLimit"), 10));
    end;
  local rotationPartNodeabl2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.abl2#index"));
    if rotationPartNodeabl2 ~= nil then
        self.rotationPartabl2 = {};
        self.rotationPartabl2.node = rotationPartNodeabl2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartabl2#minRot"));
        self.rotationPartabl2.minRot = {};
        self.rotationPartabl2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.abl2#maxRot"));
        self.rotationPartabl2.maxRot = {};
        self.rotationPartabl2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartabl2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl2#rotTime"), 2)*1000;
        self.rotationPartabl2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl2#touchRotLimit"), 10));
    end;

	
	local rotationPartNodeabl4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.abl4#index"));
    if rotationPartNodeabl4 ~= nil then
        self.rotationPartabl4 = {};
        self.rotationPartabl4.node = rotationPartNodeabl4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartabl4#minRot"));
        self.rotationPartabl4.minRot = {};
        self.rotationPartabl4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.abl4#maxRot"));
        self.rotationPartabl4.maxRot = {};
        self.rotationPartabl4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartabl4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl4#rotTime"), 2)*1000;
        self.rotationPartabl4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl4#touchRotLimit"), 10));
    end;
	
	
	
	local translationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translation2#index"));
      if translationNode2 ~= nil then
        self.translation2 = {};
        self.translation2.node = translationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation2#minTrans"));
        self.translation2.minTrans = {};
        self.translation2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation2#maxTrans"));
        self.translation2.maxTrans = {};
        self.translation2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translation2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation2#transTime"), 2)*1000;
        self.translation2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation2#touchTransLimit"), 10);
    end;
local translationNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translation1#index"));
      if translationNode1 ~= nil then
        self.translation1 = {};
        self.translation1.node = translationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation1#minTrans"));
        self.translation1.minTrans = {};
        self.translation1.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation1.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation1.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation1#maxTrans"));
        self.translation1.maxTrans = {};
        self.translation1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation1.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translation1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation1#transTime"), 2)*1000;
        self.translation1.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation1#touchTransLimit"), 10);
    end;
	
	local translationNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translation3#index"));
      if translationNode3 ~= nil then
        self.translation3 = {};
        self.translation3.node = translationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation3#minTrans"));
        self.translation3.minTrans = {};
        self.translation3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation3#maxTrans"));
        self.translation3.maxTrans = {};
        self.translation3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translation3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation3#transTime"), 2)*1000;
        self.translation3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation3#touchTransLimit"), 10);
    end;


	 
	 


	 
     end;
  
function kolos:delete()
end;

function kolos:mouseEvent(posX, posY, isDown, isUp, button)
end;

function kolos:keyEvent(unicode, sym, modifier, isDown)

	if isDown and sym == Input.KEY_f5 then 
		self.rotationMaxabl1 = not self.rotationMaxabl1;
		self.rotationMaxabl2 = not self.rotationMaxabl2;
		self.rotationMaxabl3 = not self.rotationMaxabl3;
		self.rotationMaxabl4 = not self.rotationMaxabl4;
		self.translationMax1 = not self.translationMax1;
		self.translationMax2 = not self.translationMax2;
		self.translationMax3 = not self.translationMax3;
		
	end;
	
	
	
	end;

function kolos:update(dt)
	
	       if self.rotationPartabl1 ~= nil then
	   	
		   local x, y, z = getRotation(self.rotationPartabl1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartabl1.maxRot, self.rotationPartabl1.minRot, 3, self.rotationPartabl1.rotTime, dt, not self.rotationMaxabl1);
		   setRotation(self.rotationPartabl1.node, unpack(newRot));
	       end;
	   
	   

	   		    if self.rotationPartabl2 ~= nil then
		   local x, y, z = getRotation(self.rotationPartabl2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartabl2.maxRot, self.rotationPartabl2.minRot, 3, self.rotationPartabl2.rotTime, dt, not self.rotationMaxabl2);
		   setRotation(self.rotationPartabl2.node, unpack(newRot));
	       end;
	   
	   
	   
    if self.rotationPartabl3 ~= nil then
		   local x, y, z = getRotation(self.rotationPartabl3.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartabl3.maxRot, self.rotationPartabl3.minRot, 3, self.rotationPartabl3.rotTime, dt, not self.rotationMaxabl3);
		   setRotation(self.rotationPartabl3.node, unpack(newRot));
        end;
   
       if self.rotationPartabl4 ~= nil then
		   local x, y, z = getRotation(self.rotationPartabl4.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartabl4.maxRot, self.rotationPartabl4.minRot, 3, self.rotationPartabl4.rotTime, dt, not self.rotationMaxabl4);
		   setRotation(self.rotationPartabl4.node, unpack(newRot));
  end;
   
     
	
	if self.translation1 ~= nil then 
		local x, y, z = getTranslation(self.translation1.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation1.maxTrans, self.translation1.minTrans, 3, self.translation1.transTime, dt, not self.translation1Max); 
		setTranslation(self.translation1.node, unpack(newTrans)); 
	end; 

	if self.translation2 ~= nil then 
		local x, y, z = getTranslation(self.translation2.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation2.maxTrans, self.translation2.minTrans, 3, self.translation2.transTime, dt, not self.translation2Max); 
		setTranslation(self.translation2.node, unpack(newTrans)); 
	end; 
	 

	if self.translation3 ~= nil then 
		local x, y, z = getTranslation(self.translation3.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation3.maxTrans, self.translation3.minTrans, 3, self.translation3.transTime, dt, not self.translation3Max); 
		setTranslation(self.translation2.node, unpack(newTrans)); 
	end; 
   

   
   
   
   
 end;

function kolos:draw()

end;

function kolos:onEnter()
end;

function kolos:onLeave()
end;


